<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
<script type="text/javascript">
//<![CDATA[

{literal}
Ext.onReady(function(){
    var fld = MODx.load({
    {/literal}
        xtype: 'textarea'
        ,applyTo: 'tv{$tv->id}'
        ,value: '{$tv->get('value')|escape:'javascript'}'
        ,enableKeyEvents: true
        ,msgTarget: 'under'
        ,allowBlank: {if $params.allowBlank == 1 || $params.allowBlank == 'true'}true{else}false{/if}
    {literal}
        ,listeners: { 'keydown': { fn:MODx.fireResourceFormChange, scope:this}}
    });
    MODx.makeDroppable(fld);
    Ext.getCmp('modx-panel-resource').getForm().add(fld);
});
{/literal}

if(!window.hasOwnProperty('latlang_sets')){

	// Array for some latlngTVs in the same page.
	latlang_sets = {};
}

var canvas_id = 'tv{$tv->id}_map_canvas';
var val = '{$tv->get('value')|escape:'javascript'}';

latlang_sets['tv{$tv->id}'] = {
			'canvas_id':canvas_id
			,'value':val
};

if(!window.hasOwnProperty('latLngInputChange')){

	latLngInputChange = function(id, latlng) {
		
		var p = latlng.split(",");
		var ll = new google.maps.LatLng(p[0], p[1]);
		
		latlang_sets[id].map.panTo(ll);
		latlang_sets[id].marker.setPosition(ll);
		
		MODx.fireResourceFormChange();
	}
}

if(!window.hasOwnProperty('latlang_codeAddress')){

	latlang_codeAddress = function(id) {
	
		document.getElementById(id+"_error").innerHTML = "";
		var address = document.getElementById(id+"_address").value;
		latlang_geocoder = new google.maps.Geocoder();
		latlang_geocoder.geocode({ 'address': address}, function(results, status){
			
			if (status == google.maps.GeocoderStatus.OK) {
			
				console.log(latlang_sets[id]+","+id);
				var p = results[0].geometry.location;
				document.getElementById(id).value = p.lat()+","+p.lng();
				latlang_sets[id].map.panTo(p);
				latlang_sets[id].marker.setPosition(p);
				MODx.fireResourceFormChange();
				
			} else {
			
				document.getElementById(id+"_error").innerHTML = "Error: " + status;
			}
		});
	}	
}

window.onload = function(){
	
	for(var prop in latlang_sets){
	
		var set = latlang_sets[prop];
		var ll = set.value.split(",");
		var latlng = new google.maps.LatLng(ll[0], ll[1]);
		var options = {
			zoom: 16
			,center: latlng
			,scaleControl: false
			,mapTypeControl:false
			,streetViewControl:false
			,navigationControl:true
			,mapTypeId: google.maps.MapTypeId.ROADMAP
		};
		
		set['map'] = new google.maps.Map(document.getElementById(set.canvas_id), options);
		set['marker'] = new google.maps.Marker({
		
				position: latlng
				,map: set.map
				,draggable:true
			}
		);
		
		(function(){
			var marker = set.marker;
			var map = set.map;
			var input = document.getElementById(prop);
			google.maps.event.addListener(marker, 'dragend', function(e){
				
				var p = marker.getPosition();
				input.value = p.lat()+","+p.lng();
				MODx.fireResourceFormChange();
				
				map.panTo(p);
			});
		})();
		
	}
}


//]]>
</script>
<input id="tv{$tv->id}" name="tv{$tv->id}" type="text" style="width:300px;" onChange="latLngInputChange('tv{$tv->id}',this.value)" />
<div id="tv{$tv->id}_map_canvas" style="width:400px; height:300px;margin:10px 0;"></div>
<input id="tv{$tv->id}_address" type="textbox" value="" onKeyPress="latlang_codeAddress('tv{$tv->id}')" style="width:300px; margin-right:10px;">
<input type="button" value="Search" onclick="latlang_codeAddress('tv{$tv->id}')"><br />
<span id="tv{$tv->id}_error" style="color:red;"></span>

